ldns documentation

- Main Page
- Related Pages
- Data Structures
- Files

- File List
- Globals

Functions
dane.c File Reference

Go to the source code of this file.

## Functions
ldns_status | ldns_dane_create_tlsa_owner (ldns_rdf **tlsa_owner, const ldns_rdf *name, uint16_t port, ldns_dane_transport transport)
ldns_status | ldns_dane_cert2rdf (ldns_rdf **rdf, X509 *cert, ldns_tlsa_selector selector, ldns_tlsa_matching_type matching_type)
ldns_status | ldns_dane_select_certificate (X509 **selected_cert, X509 *cert, STACK_OF(X509)*extra_certs, X509_STORE *pkix_validation_store, ldns_tlsa_certificate_usage cert_usage, int offset)
ldns_status | ldns_dane_create_tlsa_rr (ldns_rr **tlsa, ldns_tlsa_certificate_usage certificate_usage, ldns_tlsa_selector selector, ldns_tlsa_matching_type matching_type, X509 *cert)
ldns_status | ldns_dane_verify_rr (const ldns_rr *tlsa_rr, X509 *cert, STACK_OF(X509)*extra_certs, X509_STORE *pkix_validation_store)
ldns_status | ldns_dane_verify (ldns_rr_list *tlsas, X509 *cert, STACK_OF(X509)*extra_certs, X509_STORE *pkix_validation_store)

## Function Documentation

ldns_status ldns_dane_create_tlsa_owner | ( | ldns_rdf ** | tlsa_owner,
|  | const ldns_rdf * | name,
|  | uint16_t | port,
|  | ldns_dane_transport | transport
| ) |  |

Definition at line 33 of file dane.c.

References LDNS_MAX_DOMAINLEN, ldns_rdf_data(), ldns_rdf_get_type(), ldns_rdf_new_frm_data(), ldns_rdf_size(), LDNS_RDF_TYPE_DNAME, LDNS_STATUS_DANE_UNKNOWN_TRANSPORT, LDNS_STATUS_DOMAINNAME_OVERFLOW, LDNS_STATUS_MEM_ERR, and LDNS_STATUS_OK.

ldns_status ldns_dane_cert2rdf | ( | ldns_rdf ** | rdf,
|  | X509 * | cert,
|  | ldns_tlsa_selector | selector,
|  | ldns_tlsa_matching_type | matching_type
| ) |  |

Definition at line 77 of file dane.c.

References LDNS_FREE, ldns_rdf_new(), LDNS_RDF_TYPE_HEX, ldns_sha256(), LDNS_SHA256_DIGEST_LENGTH, ldns_sha512(), LDNS_SHA512_DIGEST_LENGTH, LDNS_STATUS_DANE_NON_CA_CERTIFICATE, LDNS_STATUS_DANE_OFFSET_OUT_OF_RANGE, LDNS_STATUS_DANE_PKIX_DID_NOT_VALIDATE, LDNS_STATUS_DANE_PKIX_NO_SELF_SIGNED_TRUST_ANCHOR, LDNS_STATUS_DANE_UNKNOWN_MATCHING_TYPE, LDNS_STATUS_DANE_UNKNOWN_SELECTOR, LDNS_STATUS_MEM_ERR, LDNS_STATUS_OK, LDNS_STATUS_SSL_ERR, and LDNS_XMALLOC.

ldns_status ldns_dane_select_certificate | ( | X509 ** | selected_cert,
|  | X509 * | cert,
|  | STACK_OF(X509)* | extra_certs,
|  | X509_STORE * | pkix_validation_store,
|  | ldns_tlsa_certificate_usage | cert_usage,
|  | int | offset
| ) |  |

Definition at line 348 of file dane.c.

References LDNS_STATUS_DANE_UNKNOWN_CERTIFICATE_USAGE, and LDNS_STATUS_OK.

ldns_status ldns_dane_create_tlsa_rr | ( | ldns_rr ** | tlsa,
|  | ldns_tlsa_certificate_usage | certificate_usage,
|  | ldns_tlsa_selector | selector,
|  | ldns_tlsa_matching_type | matching_type,
|  | X509 * | cert
| ) |  |

Definition at line 454 of file dane.c.

References ldns_dane_cert2rdf(), ldns_native2rdf_int8(), ldns_rdf2native_int8(), ldns_rdf_compare(), ldns_rdf_free(), LDNS_RDF_TYPE_INT8, ldns_rr_free(), ldns_rr_get_type(), ldns_rr_list_free(), ldns_rr_list_new(), ldns_rr_list_push_rr(), ldns_rr_list_rr(), ldns_rr_list_rr_count(), ldns_rr_new_frm_type(), ldns_rr_rd_count(), ldns_rr_rdf(), ldns_rr_set_rdf(), LDNS_RR_TYPE_TLSA, LDNS_STATUS_DANE_NON_CA_CERTIFICATE, LDNS_STATUS_DANE_TLSA_DID_NOT_MATCH, LDNS_STATUS_MEM_ERR, LDNS_STATUS_OK, and LDNS_STATUS_SSL_ERR.

ldns_status ldns_dane_verify_rr | ( | const ldns_rr * | tlsa_rr,
|  | X509 * | cert,
|  | STACK_OF(X509)* | extra_certs,
|  | X509_STORE * | pkix_validation_store
| ) |  |

Definition at line 597 of file dane.c.

References ldns_rdf2native_int8(), ldns_rr_rdf(), LDNS_STATUS_DANE_PKIX_DID_NOT_VALIDATE, LDNS_STATUS_DANE_UNKNOWN_CERTIFICATE_USAGE, and LDNS_STATUS_OK.

ldns_status ldns_dane_verify | ( | ldns_rr_list * | tlsas,
|  | X509 * | cert,
|  | STACK_OF(X509)* | extra_certs,
|  | X509_STORE * | pkix_validation_store
| ) |  |

Definition at line 702 of file dane.c.

References ldns_dane_verify_rr(), ldns_rr_list_free(), ldns_rr_list_rr(), ldns_rr_list_rr_count(), LDNS_STATUS_DANE_PKIX_DID_NOT_VALIDATE, LDNS_STATUS_DANE_TLSA_DID_NOT_MATCH, LDNS_STATUS_MEM_ERR, and LDNS_STATUS_OK.